// Automatically generated by FFC, the FEniCS Form Compiler, version 0.3.3.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __OPTIMIZATION_H
#define __OPTIMIZATION_H

#include <dolfin/Mesh.h>
#include <dolfin/Cell.h>
#include <dolfin/Point.h>
#include <dolfin/AffineMap.h>
#include <dolfin/FiniteElement.h>
#include <dolfin/FiniteElementSpec.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace Optimization {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 10;
    }
  
    inline unsigned int shapedim() const
    {
      return 2;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][2] = {{0, 1}, {1, 0}};
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.numVertices();
      nodes[3] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][0];
      nodes[4] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(1);
      nodes[5] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][0];
      nodes[6] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(2);
      nodes[7] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][0];
      nodes[8] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][1];
      offset = offset + 2*mesh.numEdges();
      nodes[9] = offset + cell.id();
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00);
      points[3] = map(6.666666666666667e-01, 3.333333333333333e-01);
      points[4] = map(3.333333333333334e-01, 6.666666666666666e-01);
      points[5] = map(0.000000000000000e+00, 6.666666666666667e-01);
      points[6] = map(0.000000000000000e+00, 3.333333333333334e-01);
      points[7] = map(3.333333333333333e-01, 0.000000000000000e+00);
      points[8] = map(6.666666666666666e-01, 0.000000000000000e+00);
      points[9] = map(3.333333333333333e-01, 3.333333333333333e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("Lagrange", "triangle", 3);
      return s;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class TrialElement : public dolfin::FiniteElement
  {
  public:
  
    TrialElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 10;
    }
  
    inline unsigned int shapedim() const
    {
      return 2;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][2] = {{0, 1}, {1, 0}};
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.numVertices();
      nodes[3] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][0];
      nodes[4] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(1);
      nodes[5] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][0];
      nodes[6] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(2);
      nodes[7] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][0];
      nodes[8] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][1];
      offset = offset + 2*mesh.numEdges();
      nodes[9] = offset + cell.id();
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00);
      points[3] = map(6.666666666666667e-01, 3.333333333333333e-01);
      points[4] = map(3.333333333333334e-01, 6.666666666666666e-01);
      points[5] = map(0.000000000000000e+00, 6.666666666666667e-01);
      points[6] = map(0.000000000000000e+00, 3.333333333333334e-01);
      points[7] = map(3.333333333333333e-01, 0.000000000000000e+00);
      points[8] = map(6.666666666666666e-01, 0.000000000000000e+00);
      points[9] = map(3.333333333333333e-01, 3.333333333333333e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("Lagrange", "triangle", 3);
      return s;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute geometry tensors
    const real G0_0_0 = map.det*map.g00*map.g00 + map.det*map.g01*map.g01;
    const real G0_0_1 = map.det*map.g00*map.g10 + map.det*map.g01*map.g11;
    const real G0_1_0 = map.det*map.g10*map.g00 + map.det*map.g11*map.g01;
    const real G0_1_1 = map.det*map.g10*map.g10 + map.det*map.g11*map.g11;

    // Compute element tensor
    block[73] = 1.687500000000000e-01*G0_0_1 + 1.687500000000000e-01*G0_1_0 + 3.375000000000000e-01*G0_1_1;
    block[37] = block[73];
    block[85] = -block[73] + 3.375000000000000e-01*G0_1_1;
    block[58] = block[85];
    block[75] = block[85];
    block[99] = 4.050000000000000e+00*G0_0_0 + 2.025000000000000e+00*G0_0_1 + 2.025000000000000e+00*G0_1_0 + 4.050000000000000e+00*G0_1_1;
    block[78] = -block[73] + -1.350000000000000e+00*G0_0_0 + -1.012500000000000e+00*G0_1_0;
    block[94] = -5.999999999999999e+00*block[73];
    block[86] = block[85];
    block[97] = block[94];
    block[83] = -5.000000000000000e+00*block[73];
    block[57] = block[85];
    block[74] = block[73];
    block[48] = block[73];
    block[87] = -block[73] + -1.350000000000000e+00*G0_0_0 + -1.012500000000000e+00*G0_0_1;
    block[68] = block[85];
    block[34] = -block[73] + -3.375000000000000e-01*G0_0_0 + 1.012500000000000e+00*G0_0_1;
    block[84] = block[73];
    block[59] = -block[94] + -2.025000000000000e+00*G0_1_1;
    block[69] = -block[59] + -2.025000000000000e+00*G0_0_0;
    block[67] = 8.333333333333334e-01*block[59];
    block[76] = block[67];
    block[93] = block[69];
    block[89] = block[59];
    block[54] = 8.333333333333334e-01*block[69];
    block[45] = block[54];
    block[46] = -1.666666666666667e-01*block[69];
    block[36] = block[46];
    block[64] = block[46];
    block[35] = block[46];
    block[98] = block[59];
    block[39] = block[69];
    block[96] = block[69];
    block[65] = -block[46] + -1.012500000000000e+00*G0_0_1 + -1.350000000000000e+00*G0_1_1;
    block[53] = block[46];
    block[47] = block[73];
    block[91] = block[59] + -1.012500000000000e+00*G0_0_1 + -1.012500000000000e+00*G0_1_0;
    block[16] = block[91] + -3.750000000000000e-02*G0_0_0;
    block[90] = block[91];
    block[11] = block[91] + 4.250000000000000e-01*G0_0_0;
    block[31] = -block[16] + 7.125000000000000e-01*G0_1_0;
    block[21] = block[91] + 8.750000000000001e-02*G0_1_0;
    block[1] = -block[21] + -8.750000000000001e-02*G0_0_0;
    block[51] = block[16];
    block[15] = block[16];
    block[22] = block[91] + 4.250000000000000e-01*G0_1_1;
    block[41] = -block[16] + -3.000000000000000e-01*G0_1_0;
    block[71] = -block[41] + 3.750000000000000e-01*G0_0_0;
    block[92] = block[91];
    block[61] = block[16];
    block[13] = -block[16] + 7.125000000000000e-01*G0_0_1;
    block[28] = block[91] + -3.750000000000000e-02*G0_1_1;
    block[32] = -block[28] + -3.000000000000000e-01*G0_0_1;
    block[82] = block[28];
    block[72] = block[28];
    block[27] = block[28];
    block[30] = block[28] + -3.750000000000000e-02*G0_0_0 + -3.750000000000000e-02*G0_0_1 + -3.750000000000000e-02*G0_1_0;
    block[7] = -block[30] + -7.125000000000000e-01*G0_0_0 + -7.125000000000000e-01*G0_1_0;
    block[40] = block[30];
    block[4] = block[30];
    block[60] = -block[30] + -7.125000000000000e-01*G0_1_0 + -7.125000000000000e-01*G0_1_1;
    block[5] = -block[30] + 3.000000000000000e-01*G0_0_1 + 3.000000000000000e-01*G0_1_1;
    block[8] = -block[30] + 3.000000000000000e-01*G0_0_0 + 3.000000000000000e-01*G0_1_0;
    block[80] = -block[30] + 3.000000000000000e-01*G0_0_0 + 3.000000000000000e-01*G0_0_1;
    block[62] = -block[32] + 3.750000000000000e-01*G0_1_1;
    block[50] = -block[30] + 3.000000000000000e-01*G0_1_0 + 3.000000000000000e-01*G0_1_1;
    block[14] = -block[16] + -3.000000000000000e-01*G0_0_1;
    block[23] = -block[28] + -3.000000000000000e-01*G0_1_0;
    block[26] = -block[23] + 3.750000000000000e-01*G0_1_1;
    block[19] = block[91];
    block[42] = -block[28] + 7.125000000000000e-01*G0_0_1;
    block[70] = -block[30] + -7.125000000000000e-01*G0_0_0 + -7.125000000000000e-01*G0_0_1;
    block[6] = -block[30] + -7.125000000000000e-01*G0_0_1 + -7.125000000000000e-01*G0_1_1;
    block[17] = -block[14] + 3.750000000000000e-01*G0_0_0;
    block[9] = block[91];
    block[24] = -block[28] + 7.125000000000000e-01*G0_1_0;
    block[25] = -block[24] + -6.375000000000001e-01*G0_1_1;
    block[66] = -block[54] + 1.687500000000000e+00*G0_1_1;
    block[55] = block[66];
    block[56] = -block[46] + -1.012500000000000e+00*G0_1_0 + -1.350000000000000e+00*G0_1_1;
    block[77] = block[66];
    block[3] = block[30];
    block[12] = block[91] + 8.750000000000001e-02*G0_0_1;
    block[10] = -block[12] + -8.750000000000001e-02*G0_0_0;
    block[2] = -block[12] + -8.750000000000001e-02*G0_1_1;
    block[49] = block[94];
    block[33] = block[66];
    block[29] = block[91];
    block[81] = -block[31] + -6.375000000000001e-01*G0_0_0;
    block[44] = block[66];
    block[63] = block[46];
    block[0] = block[11] + 4.250000000000000e-01*G0_0_1 + 4.250000000000000e-01*G0_1_0 + 4.250000000000000e-01*G0_1_1;
    block[79] = block[94];
    block[38] = block[83];
    block[20] = -block[21] + -8.750000000000001e-02*G0_1_1;
    block[18] = -block[13] + -6.375000000000001e-01*G0_0_0;
    block[88] = block[66];
    block[43] = -block[73] + -3.375000000000000e-01*G0_0_0 + 1.012500000000000e+00*G0_1_0;
    block[95] = block[59];
    block[52] = -block[42] + -6.375000000000001e-01*G0_1_1;
  }

  // No contribution from the boundary
  void eval(real block[], const AffineMap& map, unsigned int facet) const {}   

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:
  
  class TestElement : public dolfin::FiniteElement
  {
  public:
  
    TestElement() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 10;
    }
  
    inline unsigned int shapedim() const
    {
      return 2;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][2] = {{0, 1}, {1, 0}};
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.numVertices();
      nodes[3] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][0];
      nodes[4] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(1);
      nodes[5] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][0];
      nodes[6] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(2);
      nodes[7] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][0];
      nodes[8] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][1];
      offset = offset + 2*mesh.numEdges();
      nodes[9] = offset + cell.id();
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00);
      points[3] = map(6.666666666666667e-01, 3.333333333333333e-01);
      points[4] = map(3.333333333333334e-01, 6.666666666666666e-01);
      points[5] = map(0.000000000000000e+00, 6.666666666666667e-01);
      points[6] = map(0.000000000000000e+00, 3.333333333333334e-01);
      points[7] = map(3.333333333333333e-01, 0.000000000000000e+00);
      points[8] = map(6.666666666666666e-01, 0.000000000000000e+00);
      points[9] = map(3.333333333333333e-01, 3.333333333333333e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("Lagrange", "triangle", 3);
      return s;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
    
  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:
  
    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0), subelements(0)
    {
      // Element is scalar, don't need to initialize tensordims
  
      // Element is simple, don't need to initialize subelements
    }
  
    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
      if ( subelements )
      {
        for (unsigned int i = 0; i < elementdim(); i++)
          delete subelements[i];
        delete [] subelements;
      }
    }
  
    inline unsigned int spacedim() const
    {
      return 10;
    }
  
    inline unsigned int shapedim() const
    {
      return 2;
    }
  
    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }
  
    inline unsigned int elementdim() const
    {
      return 1;
    }
  
    inline unsigned int rank() const
    {
      return 0;
    }
  
    void nodemap(int nodes[], const Cell& cell, const Mesh& mesh) const
    {
      static unsigned int edge_reordering_0[2][2] = {{0, 1}, {1, 0}};
      nodes[0] = cell.vertexID(0);
      nodes[1] = cell.vertexID(1);
      nodes[2] = cell.vertexID(2);
      int alignment = cell.edgeAlignment(0);
      int offset = mesh.numVertices();
      nodes[3] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][0];
      nodes[4] = offset + 2*cell.edgeID(0) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(1);
      nodes[5] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][0];
      nodes[6] = offset + 2*cell.edgeID(1) + edge_reordering_0[alignment][1];
      alignment = cell.edgeAlignment(2);
      nodes[7] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][0];
      nodes[8] = offset + 2*cell.edgeID(2) + edge_reordering_0[alignment][1];
      offset = offset + 2*mesh.numEdges();
      nodes[9] = offset + cell.id();
    }
  
    void pointmap(Point points[], unsigned int components[], const AffineMap& map) const
    {
      points[0] = map(0.000000000000000e+00, 0.000000000000000e+00);
      points[1] = map(1.000000000000000e+00, 0.000000000000000e+00);
      points[2] = map(0.000000000000000e+00, 1.000000000000000e+00);
      points[3] = map(6.666666666666667e-01, 3.333333333333333e-01);
      points[4] = map(3.333333333333334e-01, 6.666666666666666e-01);
      points[5] = map(0.000000000000000e+00, 6.666666666666667e-01);
      points[6] = map(0.000000000000000e+00, 3.333333333333334e-01);
      points[7] = map(3.333333333333333e-01, 0.000000000000000e+00);
      points[8] = map(6.666666666666666e-01, 0.000000000000000e+00);
      points[9] = map(3.333333333333333e-01, 3.333333333333333e-01);
      components[0] = 0;
      components[1] = 0;
      components[2] = 0;
      components[3] = 0;
      components[4] = 0;
      components[5] = 0;
      components[6] = 0;
      components[7] = 0;
      components[8] = 0;
      components[9] = 0;
    }
  
    void vertexeval(uint vertex_nodes[], unsigned int vertex, const Mesh& mesh) const
    {
      // FIXME: Temporary fix for Lagrange elements
      vertex_nodes[0] = vertex;
    }
  
    const FiniteElement& operator[] (unsigned int i) const
    {
      return *this;
    }
  
    FiniteElement& operator[] (unsigned int i)
    {
      return *this;
    }
  
    FiniteElementSpec spec() const
    {
      FiniteElementSpec s("Lagrange", "triangle", 3);
      return s;
    }
    
  private:
  
    unsigned int* tensordims;
    FiniteElement** subelements;
  
  };
  
  LinearForm(Function& w0) : dolfin::LinearForm(1)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Add functions
    add(w0, new FunctionElement_0());
  }

  void eval(real block[], const AffineMap& map) const
  {
    // Compute coefficients
    const real c0_0 = c[0][0];
    const real c0_1 = c[0][1];
    const real c0_2 = c[0][2];
    const real c0_3 = c[0][3];
    const real c0_4 = c[0][4];
    const real c0_5 = c[0][5];
    const real c0_6 = c[0][6];
    const real c0_7 = c[0][7];
    const real c0_8 = c[0][8];
    const real c0_9 = c[0][9];

    // Compute geometry tensors
    const real G0_0 = map.det*c0_0;
    const real G0_1 = map.det*c0_1;
    const real G0_2 = map.det*c0_2;
    const real G0_3 = map.det*c0_3;
    const real G0_4 = map.det*c0_4;
    const real G0_5 = map.det*c0_5;
    const real G0_6 = map.det*c0_6;
    const real G0_7 = map.det*c0_7;
    const real G0_8 = map.det*c0_8;
    const real G0_9 = map.det*c0_9;

    // Compute element tensor
    block[0] = 5.654761904761898e-03*G0_0 + 8.184523809523806e-04*G0_1 + 8.184523809523796e-04*G0_2 + 2.008928571428569e-03*G0_3 + 2.008928571428570e-03*G0_4 + 1.339285714285713e-03*G0_6 + 1.339285714285708e-03*G0_7 + 2.678571428571429e-03*G0_9;
    block[1] = 8.184523809523809e-04*G0_0 + 5.654761904761895e-03*G0_1 + 8.184523809523795e-04*G0_2 + 1.339285714285700e-03*G0_3 + 2.008928571428572e-03*G0_5 + 2.008928571428566e-03*G0_6 + 1.339285714285706e-03*G0_8 + 2.678571428571416e-03*G0_9;
    block[2] = 8.184523809523796e-04*G0_0 + 8.184523809523796e-04*G0_1 + 5.654761904761899e-03*G0_2 + 1.339285714285713e-03*G0_4 + 1.339285714285709e-03*G0_5 + 2.008928571428571e-03*G0_7 + 2.008928571428569e-03*G0_8 + 2.678571428571422e-03*G0_9;
    block[3] = 2.008928571428569e-03*G0_0 + 1.339285714285700e-03*G0_1 + 4.017857142857136e-02*G0_3 - 1.406249999999998e-02*G0_4 - 1.004464285714285e-02*G0_5 - 4.017857142857147e-03*G0_6 - 1.004464285714285e-02*G0_7 + 2.008928571428570e-02*G0_8 + 1.205357142857144e-02*G0_9;
    block[4] = 2.008928571428570e-03*G0_0 + 1.339285714285713e-03*G0_2 - 1.406249999999998e-02*G0_3 + 4.017857142857139e-02*G0_4 + 2.008928571428570e-02*G0_5 - 1.004464285714285e-02*G0_6 - 4.017857142857136e-03*G0_7 - 1.004464285714285e-02*G0_8 + 1.205357142857142e-02*G0_9;
    block[5] = 2.008928571428572e-03*G0_1 + 1.339285714285710e-03*G0_2 - 1.004464285714285e-02*G0_3 + 2.008928571428570e-02*G0_4 + 4.017857142857139e-02*G0_5 - 1.406249999999999e-02*G0_6 - 1.004464285714284e-02*G0_7 - 4.017857142857138e-03*G0_8 + 1.205357142857142e-02*G0_9;
    block[6] = 1.339285714285713e-03*G0_0 + 2.008928571428566e-03*G0_1 - 4.017857142857146e-03*G0_3 - 1.004464285714285e-02*G0_4 - 1.406249999999999e-02*G0_5 + 4.017857142857138e-02*G0_6 + 2.008928571428570e-02*G0_7 - 1.004464285714285e-02*G0_8 + 1.205357142857141e-02*G0_9;
    block[7] = 1.339285714285707e-03*G0_0 + 2.008928571428571e-03*G0_2 - 1.004464285714285e-02*G0_3 - 4.017857142857136e-03*G0_4 - 1.004464285714284e-02*G0_5 + 2.008928571428570e-02*G0_6 + 4.017857142857141e-02*G0_7 - 1.406249999999999e-02*G0_8 + 1.205357142857142e-02*G0_9;
    block[8] = 1.339285714285706e-03*G0_1 + 2.008928571428569e-03*G0_2 + 2.008928571428570e-02*G0_3 - 1.004464285714285e-02*G0_4 - 4.017857142857138e-03*G0_5 - 1.004464285714285e-02*G0_6 - 1.406249999999999e-02*G0_7 + 4.017857142857140e-02*G0_8 + 1.205357142857143e-02*G0_9;
    block[9] = 2.678571428571429e-03*G0_0 + 2.678571428571416e-03*G0_1 + 2.678571428571422e-03*G0_2 + 1.205357142857144e-02*G0_3 + 1.205357142857142e-02*G0_4 + 1.205357142857142e-02*G0_5 + 1.205357142857141e-02*G0_6 + 1.205357142857142e-02*G0_7 + 1.205357142857143e-02*G0_8 + 1.446428571428571e-01*G0_9;
  }

  // No contribution from the boundary
  void eval(real block[], const AffineMap& map, unsigned int facet) const {}   

};

} }

#endif
